<?php

namespace FiloBlu\CegidY2\Api\CustomerWcfService\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Search ServiceType
 * @subpackage Services
 */
class Search extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named SearchCustomerIds
     * Meta information extracted from the WSDL
     * - documentation: Renvoie la liste des clients vérifiant les critères de recherche présents dans l'objet passé en paramètre d'entrée. | Renvoie une liste de fiches clients avec les informations consultables.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\SearchCustomerIds $parameters
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\SearchCustomerIdsResponse|bool
     */
    public function SearchCustomerIds(\FiloBlu\CegidY2\Api\CustomerWcfService\StructType\SearchCustomerIds $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->SearchCustomerIds($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\SearchCustomerIdsResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
