<?php

namespace FiloBlu\CegidY2\Api\CustomerWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateCustomer StructType
 * Meta information extracted from the WSDL
 * - documentation: Permet la modification d'un client existant.
 * @subpackage Structs
 */
class UpdateCustomer extends AbstractStructBase
{
    /**
     * The customerId
     * Meta information extracted from the WSDL
     * - documentation: Identifiant du client à modifier.
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $customerId;
    /**
     * The modifiedData
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerInputData
     */
    public $modifiedData;
    /**
     * The clientContext
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\RetailContext
     */
    public $clientContext;
    /**
     * Constructor method for UpdateCustomer
     * @uses UpdateCustomer::setCustomerId()
     * @uses UpdateCustomer::setModifiedData()
     * @uses UpdateCustomer::setClientContext()
     * @param string $customerId
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerInputData $modifiedData
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\RetailContext $clientContext
     */
    public function __construct($customerId = null, \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerInputData $modifiedData = null, \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\RetailContext $clientContext = null)
    {
        $this
            ->setCustomerId($customerId)
            ->setModifiedData($modifiedData)
            ->setClientContext($clientContext);
    }
    /**
     * Get customerId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCustomerId()
    {
        return isset($this->customerId) ? $this->customerId : null;
    }
    /**
     * Set customerId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $customerId
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UpdateCustomer
     */
    public function setCustomerId($customerId = null)
    {
        // validation for constraint: string
        if (!is_null($customerId) && !is_string($customerId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($customerId, true), gettype($customerId)), __LINE__);
        }
        if (is_null($customerId) || (is_array($customerId) && empty($customerId))) {
            unset($this->customerId);
        } else {
            $this->customerId = $customerId;
        }
        return $this;
    }
    /**
     * Get modifiedData value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerInputData|null
     */
    public function getModifiedData()
    {
        return isset($this->modifiedData) ? $this->modifiedData : null;
    }
    /**
     * Set modifiedData value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerInputData $modifiedData
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UpdateCustomer
     */
    public function setModifiedData(\FiloBlu\CegidY2\Api\CustomerWcfService\StructType\CustomerInputData $modifiedData = null)
    {
        if (is_null($modifiedData) || (is_array($modifiedData) && empty($modifiedData))) {
            unset($this->modifiedData);
        } else {
            $this->modifiedData = $modifiedData;
        }
        return $this;
    }
    /**
     * Get clientContext value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\RetailContext|null
     */
    public function getClientContext()
    {
        return isset($this->clientContext) ? $this->clientContext : null;
    }
    /**
     * Set clientContext value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\RetailContext $clientContext
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UpdateCustomer
     */
    public function setClientContext(\FiloBlu\CegidY2\Api\CustomerWcfService\StructType\RetailContext $clientContext = null)
    {
        if (is_null($clientContext) || (is_array($clientContext) && empty($clientContext))) {
            unset($this->clientContext);
        } else {
            $this->clientContext = $clientContext;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UpdateCustomer
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
