<?php

namespace FiloBlu\CegidY2\Api\CustomerWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateCustomerResponse StructType
 * Meta information extracted from the WSDL
 * - documentation: Permet la modification d'un client existant.
 * @subpackage Structs
 */
class UpdateCustomerResponse extends AbstractStructBase
{
    /**
     * The UpdateCustomerResult
     * Meta information extracted from the WSDL
     * - documentation: Renvoie l'identifiant du client modifié.
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $UpdateCustomerResult;
    /**
     * Constructor method for UpdateCustomerResponse
     * @uses UpdateCustomerResponse::setUpdateCustomerResult()
     * @param string $updateCustomerResult
     */
    public function __construct($updateCustomerResult = null)
    {
        $this
            ->setUpdateCustomerResult($updateCustomerResult);
    }
    /**
     * Get UpdateCustomerResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUpdateCustomerResult()
    {
        return isset($this->UpdateCustomerResult) ? $this->UpdateCustomerResult : null;
    }
    /**
     * Set UpdateCustomerResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $updateCustomerResult
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UpdateCustomerResponse
     */
    public function setUpdateCustomerResult($updateCustomerResult = null)
    {
        // validation for constraint: string
        if (!is_null($updateCustomerResult) && !is_string($updateCustomerResult)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($updateCustomerResult, true), gettype($updateCustomerResult)), __LINE__);
        }
        if (is_null($updateCustomerResult) || (is_array($updateCustomerResult) && empty($updateCustomerResult))) {
            unset($this->UpdateCustomerResult);
        } else {
            $this->UpdateCustomerResult = $updateCustomerResult;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UpdateCustomerResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
