<?php

namespace FiloBlu\CegidY2\Api\CustomerWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UserDefinedBoolean StructType
 * Meta information extracted from the WSDL
 * - documentation: Booléen libre.
 * - nillable: true
 * - type: q27:UserDefinedBoolean
 * @subpackage Structs
 */
class UserDefinedBoolean extends AbstractStructBase
{
    /**
     * The Id
     * Meta information extracted from the WSDL
     * - documentation: Identifiant.
     * - minOccurs: 0
     * @var string
     */
    public $Id;
    /**
     * The Value
     * Meta information extracted from the WSDL
     * - documentation: Valeur associée.
     * - minOccurs: 0
     * @var bool
     */
    public $Value;
    /**
     * Constructor method for UserDefinedBoolean
     * @uses UserDefinedBoolean::setId()
     * @uses UserDefinedBoolean::setValue()
     * @param string $id
     * @param bool $value
     */
    public function __construct($id = null, $value = null)
    {
        $this
            ->setId($id)
            ->setValue($value);
    }
    /**
     * Get Id value
     * @return string|null
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @uses \FiloBlu\CegidY2\Api\CustomerWcfService\EnumType\UserDefinedId::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\CustomerWcfService\EnumType\UserDefinedId::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $id
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedBoolean
     */
    public function setId($id = null)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\CustomerWcfService\EnumType\UserDefinedId::valueIsValid($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\CustomerWcfService\EnumType\UserDefinedId', is_array($id) ? implode(', ', $id) : var_export($id, true), implode(', ', \FiloBlu\CegidY2\Api\CustomerWcfService\EnumType\UserDefinedId::getValidValues())), __LINE__);
        }
        $this->Id = $id;
        return $this;
    }
    /**
     * Get Value value
     * @return bool|null
     */
    public function getValue()
    {
        return $this->Value;
    }
    /**
     * Set Value value
     * @param bool $value
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedBoolean
     */
    public function setValue($value = null)
    {
        // validation for constraint: boolean
        if (!is_null($value) && !is_bool($value)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($value, true), gettype($value)), __LINE__);
        }
        $this->Value = $value;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\CustomerWcfService\StructType\UserDefinedBoolean
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
