<?php

namespace FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAvailableQtyByStore ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfAvailableQtyByStore
 * @subpackage Arrays
 */
class ArrayOfAvailableQtyByStore extends AbstractStructArrayBase
{
    /**
     * The AvailableQtyByStore
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyByStore[]
     */
    public $AvailableQtyByStore;
    /**
     * Constructor method for ArrayOfAvailableQtyByStore
     * @uses ArrayOfAvailableQtyByStore::setAvailableQtyByStore()
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyByStore[] $availableQtyByStore
     */
    public function __construct(array $availableQtyByStore = array())
    {
        $this
            ->setAvailableQtyByStore($availableQtyByStore);
    }
    /**
     * Get AvailableQtyByStore value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyByStore[]|null
     */
    public function getAvailableQtyByStore()
    {
        return isset($this->AvailableQtyByStore) ? $this->AvailableQtyByStore : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAvailableQtyByStore method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAvailableQtyByStore method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAvailableQtyByStoreForArrayConstraintsFromSetAvailableQtyByStore(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAvailableQtyByStoreAvailableQtyByStoreItem) {
            // validation for constraint: itemType
            if (!$arrayOfAvailableQtyByStoreAvailableQtyByStoreItem instanceof \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyByStore) {
                $invalidValues[] = is_object($arrayOfAvailableQtyByStoreAvailableQtyByStoreItem) ? get_class($arrayOfAvailableQtyByStoreAvailableQtyByStoreItem) : sprintf('%s(%s)', gettype($arrayOfAvailableQtyByStoreAvailableQtyByStoreItem), var_export($arrayOfAvailableQtyByStoreAvailableQtyByStoreItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AvailableQtyByStore property can only contain items of type \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyByStore, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AvailableQtyByStore value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyByStore[] $availableQtyByStore
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfAvailableQtyByStore
     */
    public function setAvailableQtyByStore(array $availableQtyByStore = array())
    {
        // validation for constraint: array
        if ('' !== ($availableQtyByStoreArrayErrorMessage = self::validateAvailableQtyByStoreForArrayConstraintsFromSetAvailableQtyByStore($availableQtyByStore))) {
            throw new \InvalidArgumentException($availableQtyByStoreArrayErrorMessage, __LINE__);
        }
        if (is_null($availableQtyByStore) || (is_array($availableQtyByStore) && empty($availableQtyByStore))) {
            unset($this->AvailableQtyByStore);
        } else {
            $this->AvailableQtyByStore = $availableQtyByStore;
        }
        return $this;
    }
    /**
     * Add item to AvailableQtyByStore value
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyByStore $item
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfAvailableQtyByStore
     */
    public function addToAvailableQtyByStore(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyByStore $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyByStore) {
            throw new \InvalidArgumentException(sprintf('The AvailableQtyByStore property can only contain items of type \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyByStore, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AvailableQtyByStore[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyByStore|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyByStore|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyByStore|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyByStore|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyByStore|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AvailableQtyByStore
     */
    public function getAttributeName()
    {
        return 'AvailableQtyByStore';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\ArrayType\ArrayOfAvailableQtyByStore
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
