<?php

namespace FiloBlu\CegidY2\Api\ItemInventoryWcfService\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Get ServiceType
 * @subpackage Services
 */
class Get extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named GetAvailableQty
     * Meta information extracted from the WSDL
     * - documentation: Renvoie la quantité disponible en stock pour un article sans dimension ou SKU. | [Obsolète] - Référence de l’article - utilise les priorités de recherche article | Renvoie la quantité disponible en stock. la valeur 0 est
     * retournée si l'identifant de l'article ou l'identifiant dépôt sont incorrects.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableQty $parameters
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableQtyResponse|bool
     */
    public function GetAvailableQty(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableQty $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetAvailableQty($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetAvailableCumulativeQtyAllStores
     * Meta information extracted from the WSDL
     * - documentation: Renvoie le cumul des quantités disponibles en stock de tous les établissements accessibles à l’utilisateur courant. | [Obsolète] - Référence à utiliser pour déterminer l’article dont le cumul tout établissement doit
     * être retourné. | Renvoie un objet contenant à la fois le cumul des quantité disponible en stock et le status de la recherche des dépôts. Si aucun dépôt n'a pu être déterminé, la quantité cumulée vaut 0.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableCumulativeQtyAllStores $parameters
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableCumulativeQtyAllStoresResponse|bool
     */
    public function GetAvailableCumulativeQtyAllStores(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableCumulativeQtyAllStores $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetAvailableCumulativeQtyAllStores($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetInventoryDetailByStore
     * Meta information extracted from the WSDL
     * - documentation: Renvoie le détail par établissement de la quantité disponible en stock pour un article sans dimension ou SKU. | [Obsolète] - Référence à utiliser pour déterminer l’article dont le détail par établissement doit être
     * retourné. | Renvoie une liste d'associations établissement - quantité disponible. Si aucun établissement n'est ouvert ou si l'article est inconnu, renvoie une liste vide.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetInventoryDetailByStore $parameters
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetInventoryDetailByStoreResponse|bool
     */
    public function GetInventoryDetailByStore(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetInventoryDetailByStore $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetInventoryDetailByStore($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetListItemInventoryDetailByStore
     * Meta information extracted from the WSDL
     * - documentation: [Ajouté 2013/10 - V1104] - Renvoie le détail de la quantité disponible en stock pour une liste d'article (générique, sans dimension, ou SKU) et une liste de boutique. | Renvoie la liste des détails de stock
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStore $parameters
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStoreResponse|bool
     */
    public function GetListItemInventoryDetailByStore(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStore $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetListItemInventoryDetailByStore($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableCumulativeQtyAllStoresResponse|\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetAvailableQtyResponse|\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetInventoryDetailByStoreResponse|\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\GetListItemInventoryDetailByStoreResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
