<?php

namespace FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AvailableQtyReturn StructType
 * Meta information extracted from the WSDL
 * - documentation: Structure contenant deux informations. le cumul des quantités se retrouve dans le membre AvailableQty.
 * - nillable: true
 * - type: tns:AvailableQtyReturn
 * @subpackage Structs
 */
class AvailableQtyReturn extends AbstractStructBase
{
    /**
     * The AvailableQty
     * Meta information extracted from the WSDL
     * - documentation: Quantité disponible en stock de l’article déterminé. - Relatif à la colonne [DISPO.GQ_RESERVEFOU / DISPO.GQ_ANNONCELIV / DISPO.GQ_ANNONCETRF / DISPO.GQ_PROPOACHAT / DISPO.GQ_PREPACLI / DISPO.GQ_DISPOCLI / DISPO.GQ_RESERVECLI /
     * DISPO.GQ_RESERVETRF / DISPO.GQ_DEMRESERVECLI / DISPO.GQ_PANIERWEB].
     * - minOccurs: 0
     * @var float
     */
    public $AvailableQty;
    /**
     * The QueryStatus
     * Meta information extracted from the WSDL
     * - documentation: Type de retour.
     * - minOccurs: 0
     * @var string
     */
    public $QueryStatus;
    /**
     * Constructor method for AvailableQtyReturn
     * @uses AvailableQtyReturn::setAvailableQty()
     * @uses AvailableQtyReturn::setQueryStatus()
     * @param float $availableQty
     * @param string $queryStatus
     */
    public function __construct($availableQty = null, $queryStatus = null)
    {
        $this
            ->setAvailableQty($availableQty)
            ->setQueryStatus($queryStatus);
    }
    /**
     * Get AvailableQty value
     * @return float|null
     */
    public function getAvailableQty()
    {
        return $this->AvailableQty;
    }
    /**
     * Set AvailableQty value
     * @param float $availableQty
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyReturn
     */
    public function setAvailableQty($availableQty = null)
    {
        // validation for constraint: float
        if (!is_null($availableQty) && !(is_float($availableQty) || is_numeric($availableQty))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($availableQty, true), gettype($availableQty)), __LINE__);
        }
        $this->AvailableQty = $availableQty;
        return $this;
    }
    /**
     * Get QueryStatus value
     * @return string|null
     */
    public function getQueryStatus()
    {
        return $this->QueryStatus;
    }
    /**
     * Set QueryStatus value
     * @uses \FiloBlu\CegidY2\Api\ItemInventoryWcfService\EnumType\QueryExecutionStatus::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\ItemInventoryWcfService\EnumType\QueryExecutionStatus::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $queryStatus
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyReturn
     */
    public function setQueryStatus($queryStatus = null)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\ItemInventoryWcfService\EnumType\QueryExecutionStatus::valueIsValid($queryStatus)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\ItemInventoryWcfService\EnumType\QueryExecutionStatus', is_array($queryStatus) ? implode(', ', $queryStatus) : var_export($queryStatus, true), implode(', ', \FiloBlu\CegidY2\Api\ItemInventoryWcfService\EnumType\QueryExecutionStatus::getValidValues())), __LINE__);
        }
        $this->QueryStatus = $queryStatus;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\AvailableQtyReturn
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
