<?php

namespace FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateShoppingCart_Request StructType
 * Meta information extracted from the WSDL
 * - documentation: Structure des paramètres permettant la mise a jour.
 * - nillable: true
 * - type: tns:UpdateShoppingCart_Request
 * @subpackage Structs
 */
class UpdateShoppingCart_Request extends AbstractStructBase
{
    /**
     * The ItemIdentifier
     * Meta information extracted from the WSDL
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier
     */
    public $ItemIdentifier;
    /**
     * The Quantity
     * Meta information extracted from the WSDL
     * - documentation: Quantité. - Relatif à la colonne [DISPO.GQ_PANIERWEB].
     * @var float
     */
    public $Quantity;
    /**
     * The WarehouseId
     * Meta information extracted from the WSDL
     * - documentation: Identifiant du dépôt. - Relatif à la colonne [DISPO.GQ_DEPOT].
     * - nillable: true
     * @var string
     */
    public $WarehouseId;
    /**
     * Constructor method for UpdateShoppingCart_Request
     * @uses UpdateShoppingCart_Request::setItemIdentifier()
     * @uses UpdateShoppingCart_Request::setQuantity()
     * @uses UpdateShoppingCart_Request::setWarehouseId()
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier $itemIdentifier
     * @param float $quantity
     * @param string $warehouseId
     */
    public function __construct(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier $itemIdentifier = null, $quantity = null, $warehouseId = null)
    {
        $this
            ->setItemIdentifier($itemIdentifier)
            ->setQuantity($quantity)
            ->setWarehouseId($warehouseId);
    }
    /**
     * Get ItemIdentifier value
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier|null
     */
    public function getItemIdentifier()
    {
        return $this->ItemIdentifier;
    }
    /**
     * Set ItemIdentifier value
     * @param \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier $itemIdentifier
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\UpdateShoppingCart_Request
     */
    public function setItemIdentifier(\FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\ItemIdentifier $itemIdentifier = null)
    {
        $this->ItemIdentifier = $itemIdentifier;
        return $this;
    }
    /**
     * Get Quantity value
     * @return float|null
     */
    public function getQuantity()
    {
        return $this->Quantity;
    }
    /**
     * Set Quantity value
     * @param float $quantity
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\UpdateShoppingCart_Request
     */
    public function setQuantity($quantity = null)
    {
        // validation for constraint: float
        if (!is_null($quantity) && !(is_float($quantity) || is_numeric($quantity))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($quantity, true), gettype($quantity)), __LINE__);
        }
        $this->Quantity = $quantity;
        return $this;
    }
    /**
     * Get WarehouseId value
     * @return string|null
     */
    public function getWarehouseId()
    {
        return $this->WarehouseId;
    }
    /**
     * Set WarehouseId value
     * @param string $warehouseId
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\UpdateShoppingCart_Request
     */
    public function setWarehouseId($warehouseId = null)
    {
        // validation for constraint: string
        if (!is_null($warehouseId) && !is_string($warehouseId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($warehouseId, true), gettype($warehouseId)), __LINE__);
        }
        $this->WarehouseId = $warehouseId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\ItemInventoryWcfService\StructType\UpdateShoppingCart_Request
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
