<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Get ServiceType
 * @subpackage Services
 */
class Get extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named GetAvailableLoyaltyPoints
     * Meta information extracted from the WSDL
     * - documentation: Returns the points available on a loyalty card. | Identifier of the loyalty card. - Related to column [MCARETFIDENT.MFC_NUMCARTE]
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetAvailableLoyaltyPoints $parameters
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetAvailableLoyaltyPointsResponse|bool
     */
    public function GetAvailableLoyaltyPoints(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetAvailableLoyaltyPoints $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetAvailableLoyaltyPoints($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetCustomerAvailableLoyaltyPoints
     * Meta information extracted from the WSDL
     * - documentation: Returns the customer's available loyalty points. | Reference enabling the identification of the customer. | Returns the available loyalty points for the customer found.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerAvailableLoyaltyPoints $parameters
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerAvailableLoyaltyPointsResponse|bool
     */
    public function GetCustomerAvailableLoyaltyPoints(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerAvailableLoyaltyPoints $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetCustomerAvailableLoyaltyPoints($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetCustomerCards
     * Meta information extracted from the WSDL
     * - documentation: [Added 2013/04 - V1102] - Returns the list of loyalty cards associated with a customer. | List of loyalty cards
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerCards $parameters
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerCardsResponse|bool
     */
    public function GetCustomerCards(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerCards $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetCustomerCards($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetLoyaltyCard
     * Meta information extracted from the WSDL
     * - documentation: [Added 2013/04 - V1102] - Returns information from a loyalty card | Identifier of the loyalty card - Related to column [MCARETFIDENT.MFC_NUMCARTE] | Information from a loyalty card
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetLoyaltyCard $parameters
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetLoyaltyCardResponse|bool
     */
    public function GetLoyaltyCard(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetLoyaltyCard $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetLoyaltyCard($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GetLoyaltyPointsForSale
     * Meta information extracted from the WSDL
     * - documentation: [Added 2013/05 - V1102] - Returns the loyalty points earned for an existing sales document. | Query parameters | Loyalty points earned
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetLoyaltyPointsForSale $parameters
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetLoyaltyPointsForSaleResponse|bool
     */
    public function GetLoyaltyPointsForSale(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetLoyaltyPointsForSale $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->GetLoyaltyPointsForSale($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetAvailableLoyaltyPointsResponse|\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerAvailableLoyaltyPointsResponse|\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetCustomerCardsResponse|\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetLoyaltyCardResponse|\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\GetLoyaltyPointsForSaleResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
