<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CloseCard StructType
 * Meta information extracted from the WSDL
 * - documentation: [Added 2016/04 - V1110] [Beta] - Allows the customer's active card to be closed
 * @subpackage Structs
 */
class CloseCard extends AbstractStructBase
{
    /**
     * The CloseCardRequest
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CloseCardRequest
     */
    public $CloseCardRequest;
    /**
     * The clientContext
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext
     */
    public $clientContext;
    /**
     * Constructor method for CloseCard
     * @uses CloseCard::setCloseCardRequest()
     * @uses CloseCard::setClientContext()
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CloseCardRequest $closeCardRequest
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext $clientContext
     */
    public function __construct(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CloseCardRequest $closeCardRequest = null, \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext $clientContext = null)
    {
        $this
            ->setCloseCardRequest($closeCardRequest)
            ->setClientContext($clientContext);
    }
    /**
     * Get CloseCardRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CloseCardRequest|null
     */
    public function getCloseCardRequest()
    {
        return isset($this->CloseCardRequest) ? $this->CloseCardRequest : null;
    }
    /**
     * Set CloseCardRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CloseCardRequest $closeCardRequest
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CloseCard
     */
    public function setCloseCardRequest(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CloseCardRequest $closeCardRequest = null)
    {
        if (is_null($closeCardRequest) || (is_array($closeCardRequest) && empty($closeCardRequest))) {
            unset($this->CloseCardRequest);
        } else {
            $this->CloseCardRequest = $closeCardRequest;
        }
        return $this;
    }
    /**
     * Get clientContext value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext|null
     */
    public function getClientContext()
    {
        return isset($this->clientContext) ? $this->clientContext : null;
    }
    /**
     * Set clientContext value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext $clientContext
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CloseCard
     */
    public function setClientContext(\FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\RetailContext $clientContext = null)
    {
        if (is_null($clientContext) || (is_array($clientContext) && empty($clientContext))) {
            unset($this->clientContext);
        } else {
            $this->clientContext = $clientContext;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\CloseCard
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
