<?php

namespace FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateProgramRequest StructType
 * Meta information extracted from the WSDL
 * - documentation: Update of the loyalty program of the customer's active card
 * - nillable: true
 * - type: tns:UpdateProgramRequest
 * @subpackage Structs
 */
class UpdateProgramRequest extends AbstractStructBase
{
    /**
     * The LoyaltyCardId
     * Meta information extracted from the WSDL
     * - documentation: Loyalty card number - Related to column [MCARTEFIDENT.MFC_NUMCARTE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $LoyaltyCardId;
    /**
     * The ProgramId
     * Meta information extracted from the WSDL
     * - documentation: Loyalty program identifier - Related to column [MCARTEFIDENT.MFC_PROGFIDELITE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ProgramId;
    /**
     * Constructor method for UpdateProgramRequest
     * @uses UpdateProgramRequest::setLoyaltyCardId()
     * @uses UpdateProgramRequest::setProgramId()
     * @param string $loyaltyCardId
     * @param string $programId
     */
    public function __construct($loyaltyCardId = null, $programId = null)
    {
        $this
            ->setLoyaltyCardId($loyaltyCardId)
            ->setProgramId($programId);
    }
    /**
     * Get LoyaltyCardId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLoyaltyCardId()
    {
        return isset($this->LoyaltyCardId) ? $this->LoyaltyCardId : null;
    }
    /**
     * Set LoyaltyCardId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $loyaltyCardId
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdateProgramRequest
     */
    public function setLoyaltyCardId($loyaltyCardId = null)
    {
        // validation for constraint: string
        if (!is_null($loyaltyCardId) && !is_string($loyaltyCardId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($loyaltyCardId, true), gettype($loyaltyCardId)), __LINE__);
        }
        if (is_null($loyaltyCardId) || (is_array($loyaltyCardId) && empty($loyaltyCardId))) {
            unset($this->LoyaltyCardId);
        } else {
            $this->LoyaltyCardId = $loyaltyCardId;
        }
        return $this;
    }
    /**
     * Get ProgramId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getProgramId()
    {
        return isset($this->ProgramId) ? $this->ProgramId : null;
    }
    /**
     * Set ProgramId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $programId
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdateProgramRequest
     */
    public function setProgramId($programId = null)
    {
        // validation for constraint: string
        if (!is_null($programId) && !is_string($programId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($programId, true), gettype($programId)), __LINE__);
        }
        if (is_null($programId) || (is_array($programId) && empty($programId))) {
            unset($this->ProgramId);
        } else {
            $this->ProgramId = $programId;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\LoyaltyWcfService\StructType\UpdateProgramRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
