<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCreate_ShippingTax ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfCreate_ShippingTax
 * @subpackage Arrays
 */
class ArrayOfCreate_ShippingTax extends AbstractStructArrayBase
{
    /**
     * The Create_ShippingTax
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_ShippingTax[]
     */
    public $Create_ShippingTax;
    /**
     * Constructor method for ArrayOfCreate_ShippingTax
     * @uses ArrayOfCreate_ShippingTax::setCreate_ShippingTax()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_ShippingTax[] $create_ShippingTax
     */
    public function __construct(array $create_ShippingTax = array())
    {
        $this
            ->setCreate_ShippingTax($create_ShippingTax);
    }
    /**
     * Get Create_ShippingTax value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_ShippingTax[]|null
     */
    public function getCreate_ShippingTax()
    {
        return isset($this->Create_ShippingTax) ? $this->Create_ShippingTax : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCreate_ShippingTax method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCreate_ShippingTax method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCreate_ShippingTaxForArrayConstraintsFromSetCreate_ShippingTax(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCreate_ShippingTaxCreate_ShippingTaxItem) {
            // validation for constraint: itemType
            if (!$arrayOfCreate_ShippingTaxCreate_ShippingTaxItem instanceof \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_ShippingTax) {
                $invalidValues[] = is_object($arrayOfCreate_ShippingTaxCreate_ShippingTaxItem) ? get_class($arrayOfCreate_ShippingTaxCreate_ShippingTaxItem) : sprintf('%s(%s)', gettype($arrayOfCreate_ShippingTaxCreate_ShippingTaxItem), var_export($arrayOfCreate_ShippingTaxCreate_ShippingTaxItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Create_ShippingTax property can only contain items of type \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_ShippingTax, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Create_ShippingTax value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_ShippingTax[] $create_ShippingTax
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCreate_ShippingTax
     */
    public function setCreate_ShippingTax(array $create_ShippingTax = array())
    {
        // validation for constraint: array
        if ('' !== ($create_ShippingTaxArrayErrorMessage = self::validateCreate_ShippingTaxForArrayConstraintsFromSetCreate_ShippingTax($create_ShippingTax))) {
            throw new \InvalidArgumentException($create_ShippingTaxArrayErrorMessage, __LINE__);
        }
        if (is_null($create_ShippingTax) || (is_array($create_ShippingTax) && empty($create_ShippingTax))) {
            unset($this->Create_ShippingTax);
        } else {
            $this->Create_ShippingTax = $create_ShippingTax;
        }
        return $this;
    }
    /**
     * Add item to Create_ShippingTax value
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_ShippingTax $item
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCreate_ShippingTax
     */
    public function addToCreate_ShippingTax(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_ShippingTax $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_ShippingTax) {
            throw new \InvalidArgumentException(sprintf('The Create_ShippingTax property can only contain items of type \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_ShippingTax, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Create_ShippingTax[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_ShippingTax|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_ShippingTax|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_ShippingTax|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_ShippingTax|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Create_ShippingTax|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Create_ShippingTax
     */
    public function getAttributeName()
    {
        return 'Create_ShippingTax';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCreate_ShippingTax
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
