<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGet_Reply ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfGet_Reply
 * @subpackage Arrays
 */
class ArrayOfGet_Reply extends AbstractStructArrayBase
{
    /**
     * The Get_Reply
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Reply[]
     */
    public $Get_Reply;
    /**
     * Constructor method for ArrayOfGet_Reply
     * @uses ArrayOfGet_Reply::setGet_Reply()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Reply[] $get_Reply
     */
    public function __construct(array $get_Reply = array())
    {
        $this
            ->setGet_Reply($get_Reply);
    }
    /**
     * Get Get_Reply value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Reply[]|null
     */
    public function getGet_Reply()
    {
        return isset($this->Get_Reply) ? $this->Get_Reply : null;
    }
    /**
     * This method is responsible for validating the values passed to the setGet_Reply method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGet_Reply method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGet_ReplyForArrayConstraintsFromSetGet_Reply(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfGet_ReplyGet_ReplyItem) {
            // validation for constraint: itemType
            if (!$arrayOfGet_ReplyGet_ReplyItem instanceof \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Reply) {
                $invalidValues[] = is_object($arrayOfGet_ReplyGet_ReplyItem) ? get_class($arrayOfGet_ReplyGet_ReplyItem) : sprintf('%s(%s)', gettype($arrayOfGet_ReplyGet_ReplyItem), var_export($arrayOfGet_ReplyGet_ReplyItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Get_Reply property can only contain items of type \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Reply, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Get_Reply value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Reply[] $get_Reply
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfGet_Reply
     */
    public function setGet_Reply(array $get_Reply = array())
    {
        // validation for constraint: array
        if ('' !== ($get_ReplyArrayErrorMessage = self::validateGet_ReplyForArrayConstraintsFromSetGet_Reply($get_Reply))) {
            throw new \InvalidArgumentException($get_ReplyArrayErrorMessage, __LINE__);
        }
        if (is_null($get_Reply) || (is_array($get_Reply) && empty($get_Reply))) {
            unset($this->Get_Reply);
        } else {
            $this->Get_Reply = $get_Reply;
        }
        return $this;
    }
    /**
     * Add item to Get_Reply value
     * @throws \InvalidArgumentException
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Reply $item
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfGet_Reply
     */
    public function addToGet_Reply(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Reply $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Reply) {
            throw new \InvalidArgumentException(sprintf('The Get_Reply property can only contain items of type \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Reply, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Get_Reply[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Reply|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Reply|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Reply|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Reply|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Reply|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Get_Reply
     */
    public function getAttributeName()
    {
        return 'Get_Reply';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfGet_Reply
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
