<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService;

/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'HelloWorld' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\HelloWorld',
            'RetailContext' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\RetailContext',
            'HelloWorldResponse' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\HelloWorldResponse',
            'GetHeaderList' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\GetHeaderList',
            'GetHeaderList_Request' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\GetHeaderList_Request',
            'ArrayOfSaleDocumentType' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\ArrayType\\ArrayOfSaleDocumentType',
            'Pager' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Pager',
            'GetHeaderListResponse' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\GetHeaderListResponse',
            'GetHeaderList_Reply' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\GetHeaderList_Reply',
            'ArrayOfGet_Header' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\ArrayType\\ArrayOfGet_Header',
            'Get_Header' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Get_Header',
            'SaleDocumentKey' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\SaleDocumentKey',
            'OmniChannel' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\OmniChannel',
            'SaleDocumentIdentifier' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\SaleDocumentIdentifier',
            'SaleDocumentReference' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\SaleDocumentReference',
            'ArrayOfUserDefinedDate' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\ArrayType\\ArrayOfUserDefinedDate',
            'UserDefinedDate' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\UserDefinedDate',
            'ArrayOfUserDefinedTable' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\ArrayType\\ArrayOfUserDefinedTable',
            'UserDefinedTable' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\UserDefinedTable',
            'ArrayOfUserField' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\ArrayType\\ArrayOfUserField',
            'UserField' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\UserField',
            'GetByKey' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\GetByKey',
            'GetByKey_Request' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\GetByKey_Request',
            'GetByKeyResponse' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\GetByKeyResponse',
            'Get_Reply' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Get_Reply',
            'Address' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Address',
            'ArrayOfGet_Line' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\ArrayType\\ArrayOfGet_Line',
            'Get_Line' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Get_Line',
            'GetOmniChannelLine' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\GetOmniChannelLine',
            'ArrayOfGet_Payment' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\ArrayType\\ArrayOfGet_Payment',
            'Get_Payment' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Get_Payment',
            'CreditCard' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\CreditCard',
            'ArrayOfGet_ShippingTax' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\ArrayType\\ArrayOfGet_ShippingTax',
            'Get_ShippingTax' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Get_ShippingTax',
            'GetByReference' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\GetByReference',
            'GetByReference_Request' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\GetByReference_Request',
            'GetByReferenceResponse' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\GetByReferenceResponse',
            'Create' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Create',
            'Create_Request' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Create_Request',
            'Create_Header' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Create_Header',
            'SaleDocumentLineIdentifier' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\SaleDocumentLineIdentifier',
            'ArrayOfUserDefinedTableCustomer' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\ArrayType\\ArrayOfUserDefinedTableCustomer',
            'UserDefinedTableCustomer' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\UserDefinedTableCustomer',
            'ArrayOfCreate_Line' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\ArrayType\\ArrayOfCreate_Line',
            'Create_Line' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Create_Line',
            'ItemIdentifier' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\ItemIdentifier',
            'OmniChannelLine' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\OmniChannelLine',
            'ArrayOfCreate_Tax' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\ArrayType\\ArrayOfCreate_Tax',
            'Create_Tax' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Create_Tax',
            'ArrayOfCreate_Payment' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\ArrayType\\ArrayOfCreate_Payment',
            'Create_Payment' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Create_Payment',
            'ArrayOfCreate_ShippingTax' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\ArrayType\\ArrayOfCreate_ShippingTax',
            'Create_ShippingTax' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Create_ShippingTax',
            'CreateResponse' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\CreateResponse',
            'Create_Reply' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Create_Reply',
            'Cancel' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Cancel',
            'Cancel_Request' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Cancel_Request',
            'CancelResponse' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\CancelResponse',
            'Close' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Close',
            'Close_Request' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Close_Request',
            'CloseResponse' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\CloseResponse',
            'Update' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Update',
            'Update_Request' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Update_Request',
            'Update_Header' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Update_Header',
            'ArrayOfUpdate_Line' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\ArrayType\\ArrayOfUpdate_Line',
            'Update_Line' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Update_Line',
            'ArrayOfUpdate_Tax' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\ArrayType\\ArrayOfUpdate_Tax',
            'Update_Tax' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Update_Tax',
            'ArrayOfUpdate_Payment' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\ArrayType\\ArrayOfUpdate_Payment',
            'Update_Payment' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Update_Payment',
            'ArrayOfUpdate_ShippingTax' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\ArrayType\\ArrayOfUpdate_ShippingTax',
            'Update_ShippingTax' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Update_ShippingTax',
            'UpdateResponse' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\UpdateResponse',
            'UpdatePayments' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\UpdatePayments',
            'UpdatePayments_Request' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\UpdatePayments_Request',
            'UpdatePaymentsResponse' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\UpdatePaymentsResponse',
            'UpdateHeader' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\UpdateHeader',
            'UpdateHeader_Request' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\UpdateHeader_Request',
            'UpdateHeaderResponse' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\UpdateHeaderResponse',
            'GetByExternalReference' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\GetByExternalReference',
            'GetByExternalReference_Request' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\GetByExternalReference_Request',
            'GetByExternalReferenceResponse' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\GetByExternalReferenceResponse',
            'GetByExternalReference_Reply' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\GetByExternalReference_Reply',
            'ArrayOfGet_Reply' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\ArrayType\\ArrayOfGet_Reply',
            'Lock' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Lock',
            'Lock_Request' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Lock_Request',
            'LockResponse' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\LockResponse',
            'Unlock' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Unlock',
            'Unlock_Request' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\Unlock_Request',
            'UnlockResponse' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\UnlockResponse',
            'CustomersReservationCreate' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\CustomersReservationCreate',
            'CustomersReservationCreate_Request' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\CustomersReservationCreate_Request',
            'CustomersReservationCreate_Header' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\CustomersReservationCreate_Header',
            'ArrayOfCustomersReservationCreate_Line' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\ArrayType\\ArrayOfCustomersReservationCreate_Line',
            'CustomersReservationCreate_Line' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\CustomersReservationCreate_Line',
            'CustomersReservationCreateResponse' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\CustomersReservationCreateResponse',
            'CustomersReservationCreate_Reply' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\CustomersReservationCreate_Reply',
            'CbpFaultDetail' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\CbpFaultDetail',
            'BusinessFaultDetail' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\BusinessFaultDetail',
            'ExceptionDetail' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\ExceptionDetail',
            'CbpExceptionDetail' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\StructType\\CbpExceptionDetail',
            'ArrayOfstring' => '\\FiloBlu\\CegidY2\\Api\\SaleDocumentService\\ArrayType\\ArrayOfstring',
        );
    }
}
