<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\EnumType;

/**
 * This class stands for BillingStatus EnumType
 * Meta information extracted from the WSDL
 * - documentation: e-Commerce invoicing status
 * - nillable: true
 * - type: tns:BillingStatus
 * @subpackage Enumerations
 */
class BillingStatus
{
    /**
     * Constant for value 'Pending'
     * Meta information extracted from the WSDL
     * - documentation: Not invoiced.
     * @return string 'Pending'
     */
    const VALUE_PENDING = 'Pending';
    /**
     * Constant for value 'Totally'
     * Meta information extracted from the WSDL
     * - documentation: invoiced.
     * @return string 'Totally'
     */
    const VALUE_TOTALLY = 'Totally';
    /**
     * Constant for value 'Partially'
     * Meta information extracted from the WSDL
     * - documentation: Partially invoiced.
     * @return string 'Partially'
     */
    const VALUE_PARTIALLY = 'Partially';
    /**
     * Constant for value 'NotPerformed'
     * Meta information extracted from the WSDL
     * - documentation: Not realized.
     * @return string 'NotPerformed'
     */
    const VALUE_NOT_PERFORMED = 'NotPerformed';
    /**
     * Constant for value 'Performed'
     * Meta information extracted from the WSDL
     * - documentation: Realized.
     * @return string 'Performed'
     */
    const VALUE_PERFORMED = 'Performed';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_PENDING
     * @uses self::VALUE_TOTALLY
     * @uses self::VALUE_PARTIALLY
     * @uses self::VALUE_NOT_PERFORMED
     * @uses self::VALUE_PERFORMED
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_PENDING,
            self::VALUE_TOTALLY,
            self::VALUE_PARTIALLY,
            self::VALUE_NOT_PERFORMED,
            self::VALUE_PERFORMED,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
