<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\EnumType;

/**
 * This class stands for DocumentOrigin EnumType
 * Meta information extracted from the WSDL
 * - documentation: Document origin type
 * - nillable: true
 * - type: tns:DocumentOrigin
 * @subpackage Enumerations
 */
class DocumentOrigin
{
    /**
     * Constant for value 'Shop'
     * Meta information extracted from the WSDL
     * - documentation: Store.
     * @return string 'Shop'
     */
    const VALUE_SHOP = 'Shop';
    /**
     * Constant for value 'ECommerce'
     * Meta information extracted from the WSDL
     * - documentation: e-Commerce.
     * @return string 'ECommerce'
     */
    const VALUE_ECOMMERCE = 'ECommerce';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_SHOP
     * @uses self::VALUE_ECOMMERCE
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_SHOP,
            self::VALUE_ECOMMERCE,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
