<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\EnumType;

/**
 * This class stands for ReturnType EnumType
 * Meta information extracted from the WSDL
 * - documentation: Return type
 * - nillable: true
 * - type: tns:ReturnType
 * @subpackage Enumerations
 */
class ReturnType
{
    /**
     * Constant for value 'Exchange'
     * Meta information extracted from the WSDL
     * - documentation: Exchange.
     * @return string 'Exchange'
     */
    const VALUE_EXCHANGE = 'Exchange';
    /**
     * Constant for value 'Return'
     * Meta information extracted from the WSDL
     * - documentation: Return.
     * @return string 'Return'
     */
    const VALUE_RETURN = 'Return';
    /**
     * Return true if value is allowed
     * @uses self::getValidValues()
     * @param mixed $value value
     * @return bool true|false
     */
    public static function valueIsValid($value)
    {
        return ($value === null) || in_array($value, self::getValidValues(), true);
    }
    /**
     * Return allowed values
     * @uses self::VALUE_EXCHANGE
     * @uses self::VALUE_RETURN
     * @return string[]
     */
    public static function getValidValues()
    {
        return array(
            self::VALUE_EXCHANGE,
            self::VALUE_RETURN,
        );
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
