<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Lock ServiceType
 * @subpackage Services
 */
class Lock extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named Lock
     * Meta information extracted from the WSDL
     * - documentation: [Added 2013/08 - V1105] - Locks an e-Commerce sales document.
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Lock $parameters
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\LockResponse|bool
     */
    public function Lock(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Lock $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->Lock($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\LockResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
