<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreditCard StructType
 * Meta information extracted from the WSDL
 * - documentation: Credit card information.
 * - nillable: true
 * - type: tns:CreditCard
 * @subpackage Structs
 */
class CreditCard extends AbstractStructBase
{
    /**
     * The AuthorizationNumber
     * Meta information extracted from the WSDL
     * - documentation: Authorization number. - Related to column [PIEDECHE.GPE_CBNUMAUTOR].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AuthorizationNumber;
    /**
     * The TransactionNumber
     * Meta information extracted from the WSDL
     * - documentation: Transaction number. - Related to column [PIEDECHE.GPE_CBNUMTRANSAC].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $TransactionNumber;
    /**
     * Constructor method for CreditCard
     * @uses CreditCard::setAuthorizationNumber()
     * @uses CreditCard::setTransactionNumber()
     * @param string $authorizationNumber
     * @param string $transactionNumber
     */
    public function __construct($authorizationNumber = null, $transactionNumber = null)
    {
        $this
            ->setAuthorizationNumber($authorizationNumber)
            ->setTransactionNumber($transactionNumber);
    }
    /**
     * Get AuthorizationNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAuthorizationNumber()
    {
        return isset($this->AuthorizationNumber) ? $this->AuthorizationNumber : null;
    }
    /**
     * Set AuthorizationNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $authorizationNumber
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CreditCard
     */
    public function setAuthorizationNumber($authorizationNumber = null)
    {
        // validation for constraint: string
        if (!is_null($authorizationNumber) && !is_string($authorizationNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($authorizationNumber, true), gettype($authorizationNumber)), __LINE__);
        }
        if (is_null($authorizationNumber) || (is_array($authorizationNumber) && empty($authorizationNumber))) {
            unset($this->AuthorizationNumber);
        } else {
            $this->AuthorizationNumber = $authorizationNumber;
        }
        return $this;
    }
    /**
     * Get TransactionNumber value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getTransactionNumber()
    {
        return isset($this->TransactionNumber) ? $this->TransactionNumber : null;
    }
    /**
     * Set TransactionNumber value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $transactionNumber
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CreditCard
     */
    public function setTransactionNumber($transactionNumber = null)
    {
        // validation for constraint: string
        if (!is_null($transactionNumber) && !is_string($transactionNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($transactionNumber, true), gettype($transactionNumber)), __LINE__);
        }
        if (is_null($transactionNumber) || (is_array($transactionNumber) && empty($transactionNumber))) {
            unset($this->TransactionNumber);
        } else {
            $this->TransactionNumber = $transactionNumber;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CreditCard
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
