<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CustomersReservationCreate_Line StructType
 * Meta information extracted from the WSDL
 * - documentation: Customer reservation line
 * - nillable: true
 * - type: tns:CustomersReservationCreate_Line
 * @subpackage Structs
 */
class CustomersReservationCreate_Line extends AbstractStructBase
{
    /**
     * The CatalogReference
     * Meta information extracted from the WSDL
     * - documentation: [Added 2018/01 - V1400] [Optional] - Catalog reference - Related to column [LIGNESERIE.GL_REFCATALOGUE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $CatalogReference;
    /**
     * The ComplementaryDescription
     * Meta information extracted from the WSDL
     * - documentation: [Added 2015/11 - V1300] [Optional] - Complementary description for the line - Related to column [LIGNE.GL_LIBCOMPL].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ComplementaryDescription;
    /**
     * The DeliveryDate
     * Meta information extracted from the WSDL
     * - documentation: [Added 2015/11 - V1300] [Optional] - Line delivery date - Related to column [LIGNE.GL_DATELIVRAISON].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DeliveryDate;
    /**
     * The DiscountTypeId
     * Meta information extracted from the WSDL
     * - documentation: Discount type identifier. - Related to column [LIGNE.GL_TYPEREMISE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $DiscountTypeId;
    /**
     * The ExternalReference
     * Meta information extracted from the WSDL
     * - documentation: [Optional] - Line external reference. - Related to column [LIGNE.GL_REFEXTERNE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ExternalReference;
    /**
     * The InitialDeliveryDate
     * Meta information extracted from the WSDL
     * - documentation: [Added 2015/11 - V1300] [Optional] - Initial line delivery date - Related to column [LIGNE.GL_DATELIVINITIALE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $InitialDeliveryDate;
    /**
     * The ItemIdentifier
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\ItemIdentifier
     */
    public $ItemIdentifier;
    /**
     * The Label
     * Meta information extracted from the WSDL
     * - documentation: Line description. - Related to column [LIGNE.GL_LIBELLE].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Label;
    /**
     * The NetUnitPrice
     * Meta information extracted from the WSDL
     * - documentation: Net unit price. Uses [UnitPrice] to calculate the tax-inclusive or tax-exclusive line discount, based on the value of [TaxExcluded] - Related to column [LIGNE.GL_PUHTNET / LIGNE.GL_PUTTCNET].
     * - minOccurs: 0
     * @var float
     */
    public $NetUnitPrice;
    /**
     * The Quantity
     * Meta information extracted from the WSDL
     * - documentation: Quantity. - Related to column [LIGNE.GL_QTEFACT].
     * - minOccurs: 0
     * @var float
     */
    public $Quantity;
    /**
     * The SalesPersonId
     * Meta information extracted from the WSDL
     * - documentation: [Added 2014/10 - V1105] [Optional] - Seller ID for the line. - Related to column [LIGNE.GL_REPRESENTANT].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SalesPersonId;
    /**
     * The SerialNumberId
     * Meta information extracted from the WSDL
     * - documentation: [Added 2015/12 - V1300] [Optional] - Item serial number - Related to column [LIGNESERIE.GLS_IDSERIE ].
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $SerialNumberId;
    /**
     * The Taxes
     * Meta information extracted from the WSDL
     * - documentation: [Optional] - List of taxes associated with the line (max. 5 taxes.) The order in the collection determines how the document line is allocated to the 5 tax fields of the document.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCreate_Tax
     */
    public $Taxes;
    /**
     * The UnitPrice
     * Meta information extracted from the WSDL
     * - documentation: Unit price. Uses the NetUnitPrice property to calculate the tax-inclusive or tax-exclusive line discount, based on the value of [TaxExcluded] - Related to column [LIGNE.GL_PUHT / LIGNE.GL_PUTTC].
     * - minOccurs: 0
     * @var float
     */
    public $UnitPrice;
    /**
     * Constructor method for CustomersReservationCreate_Line
     * @uses CustomersReservationCreate_Line::setCatalogReference()
     * @uses CustomersReservationCreate_Line::setComplementaryDescription()
     * @uses CustomersReservationCreate_Line::setDeliveryDate()
     * @uses CustomersReservationCreate_Line::setDiscountTypeId()
     * @uses CustomersReservationCreate_Line::setExternalReference()
     * @uses CustomersReservationCreate_Line::setInitialDeliveryDate()
     * @uses CustomersReservationCreate_Line::setItemIdentifier()
     * @uses CustomersReservationCreate_Line::setLabel()
     * @uses CustomersReservationCreate_Line::setNetUnitPrice()
     * @uses CustomersReservationCreate_Line::setQuantity()
     * @uses CustomersReservationCreate_Line::setSalesPersonId()
     * @uses CustomersReservationCreate_Line::setSerialNumberId()
     * @uses CustomersReservationCreate_Line::setTaxes()
     * @uses CustomersReservationCreate_Line::setUnitPrice()
     * @param string $catalogReference
     * @param string $complementaryDescription
     * @param string $deliveryDate
     * @param string $discountTypeId
     * @param string $externalReference
     * @param string $initialDeliveryDate
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\ItemIdentifier $itemIdentifier
     * @param string $label
     * @param float $netUnitPrice
     * @param float $quantity
     * @param string $salesPersonId
     * @param string $serialNumberId
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCreate_Tax $taxes
     * @param float $unitPrice
     */
    public function __construct($catalogReference = null, $complementaryDescription = null, $deliveryDate = null, $discountTypeId = null, $externalReference = null, $initialDeliveryDate = null, \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\ItemIdentifier $itemIdentifier = null, $label = null, $netUnitPrice = null, $quantity = null, $salesPersonId = null, $serialNumberId = null, \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCreate_Tax $taxes = null, $unitPrice = null)
    {
        $this
            ->setCatalogReference($catalogReference)
            ->setComplementaryDescription($complementaryDescription)
            ->setDeliveryDate($deliveryDate)
            ->setDiscountTypeId($discountTypeId)
            ->setExternalReference($externalReference)
            ->setInitialDeliveryDate($initialDeliveryDate)
            ->setItemIdentifier($itemIdentifier)
            ->setLabel($label)
            ->setNetUnitPrice($netUnitPrice)
            ->setQuantity($quantity)
            ->setSalesPersonId($salesPersonId)
            ->setSerialNumberId($serialNumberId)
            ->setTaxes($taxes)
            ->setUnitPrice($unitPrice);
    }
    /**
     * Get CatalogReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getCatalogReference()
    {
        return isset($this->CatalogReference) ? $this->CatalogReference : null;
    }
    /**
     * Set CatalogReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $catalogReference
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line
     */
    public function setCatalogReference($catalogReference = null)
    {
        // validation for constraint: string
        if (!is_null($catalogReference) && !is_string($catalogReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($catalogReference, true), gettype($catalogReference)), __LINE__);
        }
        if (is_null($catalogReference) || (is_array($catalogReference) && empty($catalogReference))) {
            unset($this->CatalogReference);
        } else {
            $this->CatalogReference = $catalogReference;
        }
        return $this;
    }
    /**
     * Get ComplementaryDescription value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getComplementaryDescription()
    {
        return isset($this->ComplementaryDescription) ? $this->ComplementaryDescription : null;
    }
    /**
     * Set ComplementaryDescription value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $complementaryDescription
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line
     */
    public function setComplementaryDescription($complementaryDescription = null)
    {
        // validation for constraint: string
        if (!is_null($complementaryDescription) && !is_string($complementaryDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($complementaryDescription, true), gettype($complementaryDescription)), __LINE__);
        }
        if (is_null($complementaryDescription) || (is_array($complementaryDescription) && empty($complementaryDescription))) {
            unset($this->ComplementaryDescription);
        } else {
            $this->ComplementaryDescription = $complementaryDescription;
        }
        return $this;
    }
    /**
     * Get DeliveryDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDeliveryDate()
    {
        return isset($this->DeliveryDate) ? $this->DeliveryDate : null;
    }
    /**
     * Set DeliveryDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $deliveryDate
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line
     */
    public function setDeliveryDate($deliveryDate = null)
    {
        // validation for constraint: string
        if (!is_null($deliveryDate) && !is_string($deliveryDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($deliveryDate, true), gettype($deliveryDate)), __LINE__);
        }
        if (is_null($deliveryDate) || (is_array($deliveryDate) && empty($deliveryDate))) {
            unset($this->DeliveryDate);
        } else {
            $this->DeliveryDate = $deliveryDate;
        }
        return $this;
    }
    /**
     * Get DiscountTypeId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getDiscountTypeId()
    {
        return isset($this->DiscountTypeId) ? $this->DiscountTypeId : null;
    }
    /**
     * Set DiscountTypeId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $discountTypeId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line
     */
    public function setDiscountTypeId($discountTypeId = null)
    {
        // validation for constraint: string
        if (!is_null($discountTypeId) && !is_string($discountTypeId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($discountTypeId, true), gettype($discountTypeId)), __LINE__);
        }
        if (is_null($discountTypeId) || (is_array($discountTypeId) && empty($discountTypeId))) {
            unset($this->DiscountTypeId);
        } else {
            $this->DiscountTypeId = $discountTypeId;
        }
        return $this;
    }
    /**
     * Get ExternalReference value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getExternalReference()
    {
        return isset($this->ExternalReference) ? $this->ExternalReference : null;
    }
    /**
     * Set ExternalReference value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $externalReference
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line
     */
    public function setExternalReference($externalReference = null)
    {
        // validation for constraint: string
        if (!is_null($externalReference) && !is_string($externalReference)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($externalReference, true), gettype($externalReference)), __LINE__);
        }
        if (is_null($externalReference) || (is_array($externalReference) && empty($externalReference))) {
            unset($this->ExternalReference);
        } else {
            $this->ExternalReference = $externalReference;
        }
        return $this;
    }
    /**
     * Get InitialDeliveryDate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getInitialDeliveryDate()
    {
        return isset($this->InitialDeliveryDate) ? $this->InitialDeliveryDate : null;
    }
    /**
     * Set InitialDeliveryDate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $initialDeliveryDate
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line
     */
    public function setInitialDeliveryDate($initialDeliveryDate = null)
    {
        // validation for constraint: string
        if (!is_null($initialDeliveryDate) && !is_string($initialDeliveryDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($initialDeliveryDate, true), gettype($initialDeliveryDate)), __LINE__);
        }
        if (is_null($initialDeliveryDate) || (is_array($initialDeliveryDate) && empty($initialDeliveryDate))) {
            unset($this->InitialDeliveryDate);
        } else {
            $this->InitialDeliveryDate = $initialDeliveryDate;
        }
        return $this;
    }
    /**
     * Get ItemIdentifier value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\ItemIdentifier|null
     */
    public function getItemIdentifier()
    {
        return isset($this->ItemIdentifier) ? $this->ItemIdentifier : null;
    }
    /**
     * Set ItemIdentifier value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\ItemIdentifier $itemIdentifier
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line
     */
    public function setItemIdentifier(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\ItemIdentifier $itemIdentifier = null)
    {
        if (is_null($itemIdentifier) || (is_array($itemIdentifier) && empty($itemIdentifier))) {
            unset($this->ItemIdentifier);
        } else {
            $this->ItemIdentifier = $itemIdentifier;
        }
        return $this;
    }
    /**
     * Get Label value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getLabel()
    {
        return isset($this->Label) ? $this->Label : null;
    }
    /**
     * Set Label value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $label
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line
     */
    public function setLabel($label = null)
    {
        // validation for constraint: string
        if (!is_null($label) && !is_string($label)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($label, true), gettype($label)), __LINE__);
        }
        if (is_null($label) || (is_array($label) && empty($label))) {
            unset($this->Label);
        } else {
            $this->Label = $label;
        }
        return $this;
    }
    /**
     * Get NetUnitPrice value
     * @return float|null
     */
    public function getNetUnitPrice()
    {
        return $this->NetUnitPrice;
    }
    /**
     * Set NetUnitPrice value
     * @param float $netUnitPrice
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line
     */
    public function setNetUnitPrice($netUnitPrice = null)
    {
        // validation for constraint: float
        if (!is_null($netUnitPrice) && !(is_float($netUnitPrice) || is_numeric($netUnitPrice))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($netUnitPrice, true), gettype($netUnitPrice)), __LINE__);
        }
        $this->NetUnitPrice = $netUnitPrice;
        return $this;
    }
    /**
     * Get Quantity value
     * @return float|null
     */
    public function getQuantity()
    {
        return $this->Quantity;
    }
    /**
     * Set Quantity value
     * @param float $quantity
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line
     */
    public function setQuantity($quantity = null)
    {
        // validation for constraint: float
        if (!is_null($quantity) && !(is_float($quantity) || is_numeric($quantity))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($quantity, true), gettype($quantity)), __LINE__);
        }
        $this->Quantity = $quantity;
        return $this;
    }
    /**
     * Get SalesPersonId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSalesPersonId()
    {
        return isset($this->SalesPersonId) ? $this->SalesPersonId : null;
    }
    /**
     * Set SalesPersonId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $salesPersonId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line
     */
    public function setSalesPersonId($salesPersonId = null)
    {
        // validation for constraint: string
        if (!is_null($salesPersonId) && !is_string($salesPersonId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($salesPersonId, true), gettype($salesPersonId)), __LINE__);
        }
        if (is_null($salesPersonId) || (is_array($salesPersonId) && empty($salesPersonId))) {
            unset($this->SalesPersonId);
        } else {
            $this->SalesPersonId = $salesPersonId;
        }
        return $this;
    }
    /**
     * Get SerialNumberId value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getSerialNumberId()
    {
        return isset($this->SerialNumberId) ? $this->SerialNumberId : null;
    }
    /**
     * Set SerialNumberId value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $serialNumberId
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line
     */
    public function setSerialNumberId($serialNumberId = null)
    {
        // validation for constraint: string
        if (!is_null($serialNumberId) && !is_string($serialNumberId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($serialNumberId, true), gettype($serialNumberId)), __LINE__);
        }
        if (is_null($serialNumberId) || (is_array($serialNumberId) && empty($serialNumberId))) {
            unset($this->SerialNumberId);
        } else {
            $this->SerialNumberId = $serialNumberId;
        }
        return $this;
    }
    /**
     * Get Taxes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCreate_Tax|null
     */
    public function getTaxes()
    {
        return isset($this->Taxes) ? $this->Taxes : null;
    }
    /**
     * Set Taxes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCreate_Tax $taxes
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line
     */
    public function setTaxes(\FiloBlu\CegidY2\Api\SaleDocumentService\ArrayType\ArrayOfCreate_Tax $taxes = null)
    {
        if (is_null($taxes) || (is_array($taxes) && empty($taxes))) {
            unset($this->Taxes);
        } else {
            $this->Taxes = $taxes;
        }
        return $this;
    }
    /**
     * Get UnitPrice value
     * @return float|null
     */
    public function getUnitPrice()
    {
        return $this->UnitPrice;
    }
    /**
     * Set UnitPrice value
     * @param float $unitPrice
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line
     */
    public function setUnitPrice($unitPrice = null)
    {
        // validation for constraint: float
        if (!is_null($unitPrice) && !(is_float($unitPrice) || is_numeric($unitPrice))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a float value, %s given', var_export($unitPrice, true), gettype($unitPrice)), __LINE__);
        }
        $this->UnitPrice = $unitPrice;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\CustomersReservationCreate_Line
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
