<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetByKeyResponse StructType
 * Meta information extracted from the WSDL
 * - documentation: [Added 2013/04 - V1102] - Gets a sales document based on its unique key.
 * @subpackage Structs
 */
class GetByKeyResponse extends AbstractStructBase
{
    /**
     * The GetByKeyResult
     * Meta information extracted from the WSDL
     * - documentation: Returns the sales document.
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Reply
     */
    public $GetByKeyResult;
    /**
     * Constructor method for GetByKeyResponse
     * @uses GetByKeyResponse::setGetByKeyResult()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Reply $getByKeyResult
     */
    public function __construct(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Reply $getByKeyResult = null)
    {
        $this
            ->setGetByKeyResult($getByKeyResult);
    }
    /**
     * Get GetByKeyResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Reply|null
     */
    public function getGetByKeyResult()
    {
        return isset($this->GetByKeyResult) ? $this->GetByKeyResult : null;
    }
    /**
     * Set GetByKeyResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Reply $getByKeyResult
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByKeyResponse
     */
    public function setGetByKeyResult(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\Get_Reply $getByKeyResult = null)
    {
        if (is_null($getByKeyResult) || (is_array($getByKeyResult) && empty($getByKeyResult))) {
            unset($this->GetByKeyResult);
        } else {
            $this->GetByKeyResult = $getByKeyResult;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetByKeyResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
