<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GetHeaderListResponse StructType
 * Meta information extracted from the WSDL
 * - documentation: [Added 2013/04 - V1102] - Gets the list of sales history (header) for a customer. The list is sorted by decreasing dates. The 'Customer's sales query' restriction applies to the calculation of this sales history.
 * @subpackage Structs
 */
class GetHeaderListResponse extends AbstractStructBase
{
    /**
     * The GetHeaderListResult
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetHeaderList_Reply
     */
    public $GetHeaderListResult;
    /**
     * Constructor method for GetHeaderListResponse
     * @uses GetHeaderListResponse::setGetHeaderListResult()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetHeaderList_Reply $getHeaderListResult
     */
    public function __construct(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetHeaderList_Reply $getHeaderListResult = null)
    {
        $this
            ->setGetHeaderListResult($getHeaderListResult);
    }
    /**
     * Get GetHeaderListResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetHeaderList_Reply|null
     */
    public function getGetHeaderListResult()
    {
        return isset($this->GetHeaderListResult) ? $this->GetHeaderListResult : null;
    }
    /**
     * Set GetHeaderListResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetHeaderList_Reply $getHeaderListResult
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetHeaderListResponse
     */
    public function setGetHeaderListResult(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetHeaderList_Reply $getHeaderListResult = null)
    {
        if (is_null($getHeaderListResult) || (is_array($getHeaderListResult) && empty($getHeaderListResult))) {
            unset($this->GetHeaderListResult);
        } else {
            $this->GetHeaderListResult = $getHeaderListResult;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\GetHeaderListResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
