<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateHeader StructType
 * Meta information extracted from the WSDL
 * - documentation: [Added 2013/04 - V1102] - Enables the modification of header elements in a sales document.
 * @subpackage Structs
 */
class UpdateHeader extends AbstractStructBase
{
    /**
     * The updateHeaderRequest
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeader_Request
     */
    public $updateHeaderRequest;
    /**
     * The clientContext
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext
     */
    public $clientContext;
    /**
     * Constructor method for UpdateHeader
     * @uses UpdateHeader::setUpdateHeaderRequest()
     * @uses UpdateHeader::setClientContext()
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeader_Request $updateHeaderRequest
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext $clientContext
     */
    public function __construct(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeader_Request $updateHeaderRequest = null, \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext $clientContext = null)
    {
        $this
            ->setUpdateHeaderRequest($updateHeaderRequest)
            ->setClientContext($clientContext);
    }
    /**
     * Get updateHeaderRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeader_Request|null
     */
    public function getUpdateHeaderRequest()
    {
        return isset($this->updateHeaderRequest) ? $this->updateHeaderRequest : null;
    }
    /**
     * Set updateHeaderRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeader_Request $updateHeaderRequest
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeader
     */
    public function setUpdateHeaderRequest(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeader_Request $updateHeaderRequest = null)
    {
        if (is_null($updateHeaderRequest) || (is_array($updateHeaderRequest) && empty($updateHeaderRequest))) {
            unset($this->updateHeaderRequest);
        } else {
            $this->updateHeaderRequest = $updateHeaderRequest;
        }
        return $this;
    }
    /**
     * Get clientContext value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext|null
     */
    public function getClientContext()
    {
        return isset($this->clientContext) ? $this->clientContext : null;
    }
    /**
     * Set clientContext value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext $clientContext
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeader
     */
    public function setClientContext(\FiloBlu\CegidY2\Api\SaleDocumentService\StructType\RetailContext $clientContext = null)
    {
        if (is_null($clientContext) || (is_array($clientContext) && empty($clientContext))) {
            unset($this->clientContext);
        } else {
            $this->clientContext = $clientContext;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UpdateHeader
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
