<?php

namespace FiloBlu\CegidY2\Api\SaleDocumentService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UserDefinedTable StructType
 * Meta information extracted from the WSDL
 * - documentation: Data in user-defined table
 * - nillable: true
 * - type: tns:UserDefinedTable
 * @subpackage Structs
 */
class UserDefinedTable extends AbstractStructBase
{
    /**
     * The Id
     * Meta information extracted from the WSDL
     * - documentation: User-defined table ID.
     * - minOccurs: 0
     * @var string
     */
    public $Id;
    /**
     * The Value
     * Meta information extracted from the WSDL
     * - documentation: User-defined table value.
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Value;
    /**
     * Constructor method for UserDefinedTable
     * @uses UserDefinedTable::setId()
     * @uses UserDefinedTable::setValue()
     * @param string $id
     * @param string $value
     */
    public function __construct($id = null, $value = null)
    {
        $this
            ->setId($id)
            ->setValue($value);
    }
    /**
     * Get Id value
     * @return string|null
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\UserDefinedId::valueIsValid()
     * @uses \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\UserDefinedId::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $id
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UserDefinedTable
     */
    public function setId($id = null)
    {
        // validation for constraint: enumeration
        if (!\FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\UserDefinedId::valueIsValid($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\UserDefinedId', is_array($id) ? implode(', ', $id) : var_export($id, true), implode(', ', \FiloBlu\CegidY2\Api\SaleDocumentService\EnumType\UserDefinedId::getValidValues())), __LINE__);
        }
        $this->Id = $id;
        return $this;
    }
    /**
     * Get Value value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getValue()
    {
        return isset($this->Value) ? $this->Value : null;
    }
    /**
     * Set Value value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $value
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UserDefinedTable
     */
    public function setValue($value = null)
    {
        // validation for constraint: string
        if (!is_null($value) && !is_string($value)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($value, true), gettype($value)), __LINE__);
        }
        if (is_null($value) || (is_array($value) && empty($value))) {
            unset($this->Value);
        } else {
            $this->Value = $value;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \FiloBlu\CegidY2\Api\SaleDocumentService\StructType\UserDefinedTable
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
